void initMachineEtat()
{
  if (stop!=(nbEtats-1)) {Serial.println("erreur de nombre d'états !!!");while(1);}

  nbTransitions=sizeof(transitions)/sizeof(transitions[0]);
}


void processMachineEtat()
{
  static bool newState=true;
  currentTime=millis();
  if (newState)
  {
    newState=false;
    stateTime=currentTime;
  }
  int (* fonctionCourante)(void);
	fonctionCourante=fonction[etatPresent];
	codeRetour etat=fonctionCourante();

 	uint8_t nbCondition=0;
  uint32_t dureeEtat=currentTime-stateTime;
	bool next=true;
	do
	{
    struct transition * t=&transitions[nbCondition];
		if (t->etatDepart==etatPresent)
		{
      if (t->codeRet==etat)
      {
        if      ((t->dureeMaxi!=0)and(dureeEtat>t->dureeMaxi)) next=false;
        else if (dureeEtat>=t->dureeMini)
        {
          if (t->variable==nullptr)
          {
            if (t->fctCompare!=nullptr)
            {
              bool (* fonctionCompare)(void);
	            fonctionCompare=t->fctCompare;
              if (fonctionCompare()==true) next=false;
            }
          }
          else
          {
            switch (t->op)
            {
              case '>' : if (*(t->variable)> t->value)next=false;break;
              case '<' : if (*(t->variable)< t->value)next=false;break;
              case '=' : if (*(t->variable)== t->value)next=false;break;
              case '!' : if (*(t->variable)!= t->value)next=false;break;
            }
          }
        }
      }
		}
    if (next==false)
    {
      newState=true;
      etatFutur=t->etatDestination;
		  break;
    }
    else
    {
		  nbCondition++;
    }
	}
	while (nbCondition<nbTransitions);

  etatPresent=etatFutur;
}
